Index: kernel/arch/sparc64/src/trap/sun4v/interrupt.c
===================================================================
--- kernel/arch/sparc64/src/trap/sun4v/interrupt.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/arch/sparc64/src/trap/sun4v/interrupt.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -111,5 +111,5 @@
 			((void (*)(void)) data1)();
 		} else {
-			printf("Spurious interrupt on %" PRIu64 ", data = %" PRIx64 ".\n",
+			printf("Spurious interrupt on %d, data = %" PRIx64 ".\n",
 			    CPU->arch.id, data1);
 		}
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/genarch/Makefile.inc	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -122,4 +122,10 @@
 endif
 
+ifeq ($(CONFIG_PL050),y)
+	GENARCH_SOURCES += \
+		genarch/src/kbrd/kbrd_pl050.c \
+		genarch/src/kbrd/scanc_pl050.c
+endif
+
 ifeq ($(CONFIG_MAC_KBD),y)
 	GENARCH_SOURCES += \
Index: kernel/genarch/src/drivers/via-cuda/cuda.c
===================================================================
--- kernel/genarch/src/drivers/via-cuda/cuda.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/genarch/src/drivers/via-cuda/cuda.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -239,9 +239,9 @@
 	cuda_instance_t *instance = irq->instance;
 	cuda_t *dev = instance->cuda;
-	uint8_t b;
-	
+	uint8_t data, b;
+
 	b = pio_read_8(&dev->b);
-	pio_read_8(&dev->sr);
-	
+	data = pio_read_8(&dev->sr);
+
 	if ((b & TREQ) == 0) {
 		instance->xstate = cx_receive;
@@ -251,7 +251,7 @@
 		cuda_send_start(instance);
 	}
-	
-	memcpy(buf, instance->rcv_buf, instance->bidx);
-	*len = instance->bidx;
+
+        memcpy(buf, instance->rcv_buf, instance->bidx);
+        *len = instance->bidx;
 	instance->bidx = 0;
 }
Index: kernel/genarch/src/kbrd/kbrd_pl050.c
===================================================================
--- kernel/genarch/src/kbrd/kbrd_pl050.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/genarch/src/kbrd/kbrd_pl050.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,209 @@
+/*
+ * Copyright (c) 2009 Vineeth Pillai
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch
+ * @{
+ */
+/**
+ * @file
+ * @brief pl050 Keyboard processing.
+ */
+
+#include <genarch/kbrd/kbrd.h>
+#include <genarch/kbrd/scanc.h>
+
+#include <genarch/kbrd/scanc_pl050.h>
+
+#include <synch/spinlock.h>
+#include <console/chardev.h>
+#include <console/console.h>
+#include <proc/thread.h>
+#include <arch.h>
+#include <macros.h>
+
+#define PRESSED_SHIFT     (1 << 0)
+#define PRESSED_CAPSLOCK  (1 << 1)
+#define LOCKED_CAPSLOCK   (1 << 0)
+
+#define PL050_KEY_RELEASE 0xF0
+#define PL050_ESC_KEY   0xE0
+#define PL050_CAPS_SCAN_CODE   0x58
+#define PL050_NUM_SCAN_CODE   0x77
+#define PL050_SCROLL_SCAN_CODE   0x7E
+
+static bool is_lock_key(wchar_t);
+
+static indev_operations_t kbrd_raw_ops = {
+	.poll = NULL
+};
+
+/** Process release of key.
+ *
+ * @param sc Scancode of the key being released.
+ */
+static void key_released(kbrd_instance_t *instance, wchar_t sc)
+{
+	spinlock_lock(&instance->keylock);
+	
+	switch (sc) {
+	case SC_LSHIFT:
+	case SC_RSHIFT:
+		instance->keyflags &= ~PRESSED_SHIFT;
+		break;
+	case SC_CAPSLOCK:
+		instance->keyflags &= ~PRESSED_CAPSLOCK;
+		if (instance->lockflags & LOCKED_CAPSLOCK)
+			instance->lockflags &= ~LOCKED_CAPSLOCK;
+		else
+			instance->lockflags |= LOCKED_CAPSLOCK;
+		break;
+	default:
+		break;
+	}
+	
+	spinlock_unlock(&instance->keylock);
+}
+
+/** Process keypress.
+ *
+ * @param sc Scancode of the key being pressed.
+ */
+static void key_pressed(kbrd_instance_t *instance, wchar_t sc)
+{
+	bool letter;
+	bool shift;
+	bool capslock;
+	
+	spinlock_lock(&instance->keylock);
+	
+	switch (sc) {
+	case SC_LSHIFT:
+	case SC_RSHIFT:
+		instance->keyflags |= PRESSED_SHIFT;
+		break;
+	case SC_CAPSLOCK:
+		instance->keyflags |= PRESSED_CAPSLOCK;
+		break;
+	case SC_SCAN_ESCAPE:
+		break;
+	default:
+		letter = islower(sc_primary_map[sc]);
+		shift = instance->keyflags & PRESSED_SHIFT;
+		capslock = (instance->keyflags & PRESSED_CAPSLOCK) ||
+		    (instance->lockflags & LOCKED_CAPSLOCK);
+		
+		if ((letter) && (capslock))
+			shift = !shift;
+		
+		if (shift)
+			indev_push_character(instance->sink, sc_secondary_map[sc]);
+		else
+			indev_push_character(instance->sink, sc_primary_map[sc]);
+		break;
+	}
+	
+	spinlock_unlock(&instance->keylock);
+}
+
+static void kkbrd(void *arg)
+{
+	static int key_released_flag = 0;
+	static int is_locked = 0;
+	kbrd_instance_t *instance = (kbrd_instance_t *) arg;
+	
+	while (true) {
+		wchar_t sc = indev_pop_character(&instance->raw);
+
+		if (sc == PL050_KEY_RELEASE) {
+			key_released_flag = 1;
+		} else {
+			if (key_released_flag) {
+				key_released_flag = 0;
+				if (is_lock_key(sc)) {
+					if (!is_locked) {
+						is_locked = 1;
+					} else {
+						is_locked = 0;
+						continue;
+					}
+				}
+				key_released(instance, sc);
+
+			} else {
+				if (is_lock_key(sc) && is_locked)
+					continue;
+				key_pressed(instance, sc);
+			}
+		}
+		
+	}
+}
+
+kbrd_instance_t *kbrd_init(void)
+{
+	kbrd_instance_t *instance
+	    = malloc(sizeof(kbrd_instance_t), FRAME_ATOMIC);
+	if (instance) {
+		instance->thread
+			= thread_create(kkbrd, (void *) instance, TASK, 0, "kkbrd", false);
+		
+		if (!instance->thread) {
+			free(instance);
+			return NULL;
+		}
+		
+		instance->sink = NULL;
+		indev_initialize("kbrd", &instance->raw, &kbrd_raw_ops);
+		
+		spinlock_initialize(&instance->keylock, "kbrd_pl050.instance.keylock");
+		instance->keyflags = 0;
+		instance->lockflags = 0;
+	}
+	
+	return instance;
+}
+
+indev_t *kbrd_wire(kbrd_instance_t *instance, indev_t *sink)
+{
+	ASSERT(instance);
+	ASSERT(sink);
+	
+	instance->sink = sink;
+	thread_ready(instance->thread);
+	
+	return &instance->raw;
+}
+
+static bool is_lock_key(wchar_t sc)
+{
+	return ((sc == PL050_CAPS_SCAN_CODE) || (sc == PL050_NUM_SCAN_CODE) ||
+		(sc == PL050_SCROLL_SCAN_CODE));
+}
+
+/** @}
+ */
Index: kernel/genarch/src/kbrd/scanc_pl050.c
===================================================================
--- kernel/genarch/src/kbrd/scanc_pl050.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ kernel/genarch/src/kbrd/scanc_pl050.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,234 @@
+/*
+ * Copyright (c) 2009 Vineeth Pillai
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, U_SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup genarch	
+ * @{
+ */
+/**
+ * @file
+ * @brief	Scan codes for pl050 keyboards.
+ */
+#include <genarch/kbrd/scanc.h>
+#include <typedefs.h>
+#include <str.h>
+
+
+/** Primary meaning of scancodes. */
+wchar_t sc_primary_map[] = {
+	U_NULL, /* 0x00 */
+	U_SPECIAL, /* 0x01 - F9 */
+	U_SPECIAL, /* 0x02 - F7 */
+	U_SPECIAL, /* 0x03 - F5 */
+	U_SPECIAL, /* 0x04 - F3 */
+	U_SPECIAL, /* 0x05 - F1 */
+	U_SPECIAL, /* 0x06 - F2 */
+	U_SPECIAL, /* 0x07 - F12 */
+	U_SPECIAL, /* 0x08 -  */
+	U_SPECIAL, /* 0x09 - F10 */
+	U_SPECIAL, /* 0x0A - F8 */
+	U_SPECIAL, /* 0x0B - F10 */
+	U_SPECIAL, /* 0x0C - F4 */
+	'\t', /* 0x0D - Tab */
+	'`',
+	U_SPECIAL, /* 0x0F */
+	U_SPECIAL, /* 0x10 */
+	U_SPECIAL, /* 0x11 - LAlt */
+	U_SPECIAL, /* 0x12 - LShift */
+	U_SPECIAL, /* ox13 */
+	U_SPECIAL, /* 0x14 Ctrl */
+	'q', '1',
+	U_SPECIAL, /* 0x17 */
+	U_SPECIAL, /* 0x18 */
+	U_SPECIAL, /* 0x19 */
+	'z', 's', 'a', 'w', '2',
+	U_SPECIAL, /* 0x1F */
+	U_SPECIAL, /* 0x20 */
+	'c', 'x', 'd', 'e', '4', '3',
+	U_SPECIAL, /* 0x27 */
+	U_SPECIAL, /* 0x28 */
+	' ', 'v', 'f', 't', 'r', '5',
+	U_SPECIAL, /* 0x2F */
+	U_SPECIAL, /* 0x30 */
+	'n', 'b', 'h', 'g', 'y', '6',
+	U_SPECIAL, /* 0x37 */
+	U_SPECIAL, /* 0x38 */
+	U_SPECIAL, /* 0x39 */
+	'm', 'j', 'u', '7', '8',
+	U_SPECIAL, /* 0x3F */
+	U_SPECIAL, /* 0x40 */
+	',', 'k', 'i', 'o', '0', '9',
+	U_SPECIAL, /* 0x47 */
+	U_SPECIAL, /* 0x48 */
+	'.', '/', 'l', ';', 'p', '-',
+	U_SPECIAL, /* 0x4F */
+	U_SPECIAL, /* 0x50 */
+	U_SPECIAL, /* 0x51 */
+	'\'',
+	U_SPECIAL, /* 0x53 */
+	'[', '=',
+	U_SPECIAL, /* 0x56 */
+	U_SPECIAL, /* 0x57 */
+	U_SPECIAL, /* 0x58 - Caps Lock */
+	U_SPECIAL, /* 0x59 - RShift */
+	'\n', ']',
+	U_SPECIAL, /* 0x5C */
+	'\\',
+	U_SPECIAL, /* 0x5E */
+	U_SPECIAL, /* 0x5F */
+	U_SPECIAL, /* 0x60 */
+	U_SPECIAL, /* 0x61 */
+	U_SPECIAL, /* 0x62 */
+	U_SPECIAL, /* 0x63 */
+	U_SPECIAL, /* 0x64 */
+	U_SPECIAL, /* 0x65 */
+	'\b', /* 0x66  - backspace*/
+	U_SPECIAL, /* 0x67 */
+	U_SPECIAL, /* 0x68 */
+	U_END_ARROW, /* 0x69 */
+	U_SPECIAL, /* 0x6a */
+	U_LEFT_ARROW, /* 0x6b - Left Arrow */
+	U_SPECIAL, /* 0x6c */
+	U_SPECIAL, /* 0x6d */
+	U_SPECIAL, /* 0x6e */
+	U_SPECIAL, /* 0x6f */
+	U_SPECIAL, /* 0x70 */
+	U_DELETE, /* 0x71 - Del*/
+	U_DOWN_ARROW, /* 0x72 Down Arrow */
+	U_SPECIAL, /* 0x73 */
+	U_RIGHT_ARROW, /* 0x74  - Right Arrow */
+	U_UP_ARROW, /* 0x75  Up Arrow */
+	U_ESCAPE, /* 0x76 Esc */
+	U_SPECIAL, /* 0x77 - NumLock*/
+	U_SPECIAL, /* 0x78  F11*/
+	U_SPECIAL, /* 0x79 */
+	U_PAGE_DOWN, /* 0x7a */
+	U_SPECIAL, /* 0x7b */
+	U_SPECIAL, /* 0x7c */
+	U_PAGE_UP, /* 0x7d */
+	U_SPECIAL, /* 0x7e */
+	U_SPECIAL /* 0x7f */
+};
+
+/** Secondary meaning of scancodes. */
+wchar_t sc_secondary_map[] = {
+	U_NULL, /* 0x00 */
+	U_SPECIAL, /* 0x01 - F9 */
+	U_SPECIAL, /* 0x02 - F7 */
+	U_SPECIAL, /* 0x03 - F5 */
+	U_SPECIAL, /* 0x04 - F3 */
+	U_SPECIAL, /* 0x05 - F1 */
+	U_SPECIAL, /* 0x06 - F2 */
+	U_SPECIAL, /* 0x07 - F12 */
+	U_SPECIAL, /* 0x08 -  */
+	U_SPECIAL, /* 0x09 - F10 */
+	U_SPECIAL, /* 0x0A - F8 */
+	U_SPECIAL, /* 0x0B - F10 */
+	U_SPECIAL, /* 0x0C - F4 */
+	'\t', /* 0x0D - Tab */
+	'~',
+	U_SPECIAL, /* 0x0F */
+	U_SPECIAL, /* 0x10 */
+	U_SPECIAL, /* 0x11 - LAlt */
+	U_SPECIAL, /* 0x12 - LShift */
+	U_SPECIAL, /* ox13 */
+	U_SPECIAL, /* 0x14 Ctrl */
+	'Q', '!',
+	U_SPECIAL, /* 0x17 */
+	U_SPECIAL, /* 0x18 */
+	U_SPECIAL, /* 0x19 */
+	'Z', 'S', 'A', 'W', '@',
+	U_SPECIAL, /* 0x1F */
+	U_SPECIAL, /* 0x20 */
+	'C', 'X', 'D', 'E', '$', '#',
+	U_SPECIAL, /* 0x27 */
+	U_SPECIAL, /* 0x28 */
+	' ', 'V', 'F', 'T', 'R', '%',
+	U_SPECIAL, /* 0x2F */
+	U_SPECIAL, /* 0x30 */
+	'N', 'B', 'H', 'G', 'Y', '^',
+	U_SPECIAL, /* 0x37 */
+	U_SPECIAL, /* 0x38 */
+	U_SPECIAL, /* 0x39 */
+	'M', 'J', 'U', '&', '*',
+	U_SPECIAL, /* 0x3F */
+	U_SPECIAL, /* 0x40 */
+	'<', 'K', 'I', 'O', ')', '(',
+	U_SPECIAL, /* 0x47 */
+	U_SPECIAL, /* 0x48 */
+	'>', '?', 'L', ':', 'P', '_',
+	U_SPECIAL, /* 0x4F */
+	U_SPECIAL, /* 0x50 */
+	U_SPECIAL, /* 0x51 */
+	'"',
+	U_SPECIAL, /* 0x53 */
+	'{', '+',
+	U_SPECIAL, /* 0x56 */
+	U_SPECIAL, /* 0x57 */
+	U_SPECIAL, /* 0x58 - Caps Lock */
+	U_SPECIAL, /* 0x59 - RShift */
+	'\n', '}',
+	U_SPECIAL, /* 0x5C */
+	'|',
+	U_SPECIAL, /* 0x5E */
+	U_SPECIAL, /* 0x5F */
+	U_SPECIAL, /* 0x60 */
+	U_SPECIAL, /* 0x61 */
+	U_SPECIAL, /* 0x62 */
+	U_SPECIAL, /* 0x63 */
+	U_SPECIAL, /* 0x64 */
+	U_SPECIAL, /* 0x65 */
+	'\b', /* 0x66  - backspace*/
+	U_SPECIAL, /* 0x67 */
+	U_SPECIAL, /* 0x68 */
+	U_END_ARROW, /* 0x69 */
+	U_SPECIAL, /* 0x6a */
+	U_LEFT_ARROW, /* 0x6b - Left Arrow */
+	U_SPECIAL, /* 0x6c */
+	U_SPECIAL, /* 0x6d */
+	U_SPECIAL, /* 0x6e */
+	U_SPECIAL, /* 0x6f */
+	U_SPECIAL, /* 0x70 */
+	U_DELETE, /* 0x71 - Del*/
+	U_DOWN_ARROW, /* 0x72 Down Arrow */
+	U_SPECIAL, /* 0x73 */
+	U_RIGHT_ARROW, /* 0x74  - Right Arrow */
+	U_UP_ARROW, /* 0x75  Up Arrow */
+	U_ESCAPE, /* 0x76 Esc */
+	U_SPECIAL, /* 0x77 - NumLock*/
+	U_SPECIAL, /* 0x78  F11*/
+	U_SPECIAL, /* 0x79 */
+	U_PAGE_DOWN, /* 0x7a */
+	U_SPECIAL, /* 0x7b */
+	U_SPECIAL, /* 0x7c */
+	U_PAGE_UP, /* 0x7d */
+	U_SPECIAL, /* 0x7e */
+	U_SPECIAL /* 0x7f */
+};
+
+/** @}
+ */
Index: kernel/genarch/src/ofw/ebus.c
===================================================================
--- kernel/genarch/src/ofw/ebus.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/genarch/src/ofw/ebus.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -39,4 +39,5 @@
 #include <genarch/ofw/ebus.h>
 #include <genarch/ofw/pci.h>
+#include <arch/memstr.h>
 #include <str.h>
 #include <panic.h>
Index: kernel/genarch/src/ofw/fhc.c
===================================================================
--- kernel/genarch/src/ofw/fhc.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/genarch/src/ofw/fhc.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -39,4 +39,5 @@
 #include <genarch/ofw/fhc.h>
 #include <arch/drivers/fhc.h>
+#include <arch/memstr.h>
 #include <str.h>
 #include <panic.h>
Index: kernel/genarch/src/ofw/ofw_tree.c
===================================================================
--- kernel/genarch/src/ofw/ofw_tree.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/genarch/src/ofw/ofw_tree.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -37,6 +37,6 @@
 
 #include <genarch/ofw/ofw_tree.h>
+#include <arch/memstr.h>
 #include <mm/slab.h>
-#include <memstr.h>
 #include <str.h>
 #include <panic.h>
Index: kernel/genarch/src/ofw/pci.c
===================================================================
--- kernel/genarch/src/ofw/pci.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/genarch/src/ofw/pci.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -40,4 +40,5 @@
 #include <arch/drivers/pci.h>
 #include <arch/trap/interrupt.h>
+#include <arch/memstr.h>
 #include <str.h>
 #include <panic.h>
Index: kernel/genarch/src/ofw/upa.c
===================================================================
--- kernel/genarch/src/ofw/upa.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/genarch/src/ofw/upa.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -38,4 +38,5 @@
 #include <genarch/ofw/ofw_tree.h>
 #include <genarch/ofw/upa.h>
+#include <arch/memstr.h>
 #include <func.h>
 #include <panic.h>
Index: kernel/generic/include/memstr.h
===================================================================
--- kernel/generic/include/memstr.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/generic/include/memstr.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -37,11 +37,13 @@
 
 #include <typedefs.h>
+#include <arch/memstr.h>
 
-#define memset(dst, val, cnt)  __builtin_memset((dst), (val), (cnt))
-#define memcpy(dst, src, cnt)  __builtin_memcpy((dst), (src), (cnt))
-
-extern void memsetb(void *, size_t, uint8_t);
-extern void memsetw(void *, size_t, uint16_t);
-extern void *memmove(void *, const void *, size_t);
+/*
+ * Architecture independent variants.
+ */
+extern void *_memcpy(void *dst, const void *src, size_t cnt);
+extern void _memsetb(void *dst, size_t cnt, uint8_t x);
+extern void _memsetw(void *dst, size_t cnt, uint16_t x);
+extern void *memmove(void *dst, const void *src, size_t cnt);
 
 #endif
Index: kernel/generic/src/lib/memstr.c
===================================================================
--- kernel/generic/src/lib/memstr.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/generic/src/lib/memstr.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -28,5 +28,5 @@
  */
 
-/** @addtogroup generic
+/** @addtogroup generic	
  * @{
  */
@@ -34,90 +34,129 @@
 /**
  * @file
- * @brief Memory string operations.
+ * @brief	Memory string operations.
  *
- * This file provides architecture independent functions to manipulate blocks
- * of memory. These functions are optimized as much as generic functions of
- * this type can be.
+ * This file provides architecture independent functions to manipulate blocks of
+ * memory. These functions are optimized as much as generic functions of this
+ * type can be. However, architectures are free to provide even more optimized
+ * versions of these functions.
  */
 
 #include <memstr.h>
 #include <typedefs.h>
+#include <align.h>
 
-/** Fill block of memory.
+/** Copy block of memory.
  *
- * Fill cnt bytes at dst address with the value val.
+ * Copy cnt bytes from src address to dst address.  The copying is done
+ * word-by-word and then byte-by-byte.  The source and destination memory areas
+ * cannot overlap.
  *
- * @param dst Destination address to fill.
- * @param cnt Number of bytes to fill.
- * @param val Value to fill.
+ * @param src		Source address to copy from.
+ * @param dst		Destination address to copy to.
+ * @param cnt		Number of bytes to copy.
+ *
+ * @return		Destination address.
+ */
+void *_memcpy(void *dst, const void *src, size_t cnt)
+{
+	unsigned int i, j;
+	
+	if (ALIGN_UP((uintptr_t) src, sizeof(sysarg_t)) != (uintptr_t) src ||
+	    ALIGN_UP((uintptr_t) dst, sizeof(sysarg_t)) != (uintptr_t) dst) {
+		for (i = 0; i < cnt; i++)
+			((uint8_t *) dst)[i] = ((uint8_t *) src)[i];
+	} else { 
+		for (i = 0; i < cnt / sizeof(sysarg_t); i++)
+			((sysarg_t *) dst)[i] = ((sysarg_t *) src)[i];
+		
+		for (j = 0; j < cnt % sizeof(sysarg_t); j++)
+			((uint8_t *)(((sysarg_t *) dst) + i))[j] =
+			    ((uint8_t *)(((sysarg_t *) src) + i))[j];
+	}
+		
+	return (char *) dst;
+}
+
+/** Move memory block with possible overlapping.
+ *
+ * Copy cnt bytes from src address to dst address. The source and destination
+ * memory areas may overlap.
+ *
+ * @param src		Source address to copy from.
+ * @param dst		Destination address to copy to.
+ * @param cnt		Number of bytes to copy.
+ *
+ * @return		Destination address.
+ */
+void *memmove(void *dst, const void *src, size_t n)
+{
+	const uint8_t *sp;
+	uint8_t *dp;
+
+	/* Nothing to do? */
+	if (src == dst)
+		return dst;
+
+	/* Non-overlapping? */
+	if (dst >= src + n || src >= dst + n) {	
+		return memcpy(dst, src, n);
+	}
+
+	/* Which direction? */
+	if (src > dst) {
+		/* Forwards. */
+		sp = src;
+		dp = dst;
+
+		while (n-- != 0)
+			*dp++ = *sp++;
+	} else {
+		/* Backwards. */
+		sp = src + (n - 1);
+		dp = dst + (n - 1);
+
+		while (n-- != 0)
+			*dp-- = *sp--;
+	}
+
+	return dst;
+}
+
+/** Fill block of memory
+ *
+ * Fill cnt bytes at dst address with the value x.  The filling is done
+ * byte-by-byte.
+ *
+ * @param dst		Destination address to fill.
+ * @param cnt		Number of bytes to fill.
+ * @param x		Value to fill.
  *
  */
-void memsetb(void *dst, size_t cnt, uint8_t val)
+void _memsetb(void *dst, size_t cnt, uint8_t x)
 {
-	memset(dst, val, cnt);
+	unsigned int i;
+	uint8_t *p = (uint8_t *) dst;
+	
+	for (i = 0; i < cnt; i++)
+		p[i] = x;
 }
 
 /** Fill block of memory.
  *
- * Fill cnt words at dst address with the value val. The filling
- * is done word-by-word.
+ * Fill cnt words at dst address with the value x.  The filling is done
+ * word-by-word.
  *
- * @param dst Destination address to fill.
- * @param cnt Number of words to fill.
- * @param val Value to fill.
+ * @param dst		Destination address to fill.
+ * @param cnt		Number of words to fill.
+ * @param x		Value to fill.
  *
  */
-void memsetw(void *dst, size_t cnt, uint16_t val)
+void _memsetw(void *dst, size_t cnt, uint16_t x)
 {
-	size_t i;
-	uint16_t *ptr = (uint16_t *) dst;
+	unsigned int i;
+	uint16_t *p = (uint16_t *) dst;
 	
 	for (i = 0; i < cnt; i++)
-		ptr[i] = val;
-}
-
-/** Move memory block with possible overlapping.
- *
- * Copy cnt bytes from src address to dst address. The source
- * and destination memory areas may overlap.
- *
- * @param dst Destination address to copy to.
- * @param src Source address to copy from.
- * @param cnt Number of bytes to copy.
- *
- * @return Destination address.
- *
- */
-void *memmove(void *dst, const void *src, size_t cnt)
-{
-	/* Nothing to do? */
-	if (src == dst)
-		return dst;
-	
-	/* Non-overlapping? */
-	if ((dst >= src + cnt) || (src >= dst + cnt))
-		return memcpy(dst, src, cnt);
-	
-	uint8_t *dp;
-	const uint8_t *sp;
-	
-	/* Which direction? */
-	if (src > dst) {
-		/* Forwards. */
-		dp = dst;
-		sp = src;
-		
-		while (cnt-- != 0)
-			*dp++ = *sp++;
-	} else {
-		/* Backwards. */
-		dp = dst + (cnt - 1);
-		sp = src + (cnt - 1);
-		
-		while (cnt-- != 0)
-			*dp-- = *sp--;
-	}
-	
-	return dst;
+		p[i] = x;	
 }
 
Index: kernel/generic/src/mm/backend_elf.c
===================================================================
--- kernel/generic/src/mm/backend_elf.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/generic/src/mm/backend_elf.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -91,11 +91,7 @@
 	if (!as_area_check_access(area, access))
 		return AS_PF_FAULT;
-	
-	if (addr < ALIGN_DOWN(entry->p_vaddr, PAGE_SIZE))
-		return AS_PF_FAULT;
-	
-	if (addr >= entry->p_vaddr + entry->p_memsz)
-		return AS_PF_FAULT;
-	
+
+	ASSERT((addr >= ALIGN_DOWN(entry->p_vaddr, PAGE_SIZE)) &&
+	    (addr < entry->p_vaddr + entry->p_memsz));
 	i = (addr - ALIGN_DOWN(entry->p_vaddr, PAGE_SIZE)) >> PAGE_WIDTH;
 	base = (uintptr_t)
Index: kernel/tools/genmap.py
===================================================================
--- kernel/tools/genmap.py	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ kernel/tools/genmap.py	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -100,9 +100,8 @@
 			for addr, symbol in symbols:
 				value = fname + ':' + symbol
-				value_bytes = value.encode('ascii')
-				data = struct.pack(symtabfmt, addr + offset, value_bytes[:MAXSTRING])
+				data = struct.pack(symtabfmt, addr + offset, value[:MAXSTRING])
 				out.write(data)
 			
-	out.write(struct.pack(symtabfmt, 0, b''))
+	out.write(struct.pack(symtabfmt, 0, ''))
 
 def main():
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ tools/autotool.py	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -501,5 +501,5 @@
 		cross_prefix = os.environ['CROSS_PREFIX']
 	else:
-		cross_prefix = "/usr/local/cross"
+		cross_prefix = "/usr/local"
 	
 	# Prefix binutils tools on Solaris
Index: tools/mkfat.py
===================================================================
--- tools/mkfat.py	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ tools/mkfat.py	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -211,6 +211,6 @@
 	dir_entry = xstruct.create(DIR_ENTRY)
 	
-	dir_entry.name = mangle_fname(name).encode('ascii')
-	dir_entry.ext = mangle_ext(name).encode('ascii')
+	dir_entry.name = mangle_fname(name)
+	dir_entry.ext = mangle_ext(name)
 	
 	if (directory):
@@ -239,6 +239,6 @@
 	
 	dir_entry.signature = 0x2e
-	dir_entry.name = b'       '
-	dir_entry.ext = b'   '
+	dir_entry.name = '       '
+	dir_entry.ext = '   '
 	dir_entry.attr = 0x10
 	
@@ -258,6 +258,6 @@
 	
 	dir_entry.signature = [0x2e, 0x2e]
-	dir_entry.name = b'      '
-	dir_entry.ext = b'   '
+	dir_entry.name = '      '
+	dir_entry.ext = '   '
 	dir_entry.attr = 0x10
 	
Index: tools/mkhord.py
===================================================================
--- tools/mkhord.py	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ tools/mkhord.py	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -84,5 +84,5 @@
 	payload_size_aligned = align_up(payload_size, align)
 	
-	header.tag = b"HORD"
+	header.tag = "HORD"
 	header.version = 1
 	header.encoding = HORD_LSB
Index: tools/mktmpfs.py
===================================================================
--- tools/mktmpfs.py	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ tools/mktmpfs.py	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -80,5 +80,5 @@
 			dentry.kind = TMPFS_FILE
 			dentry.fname_len = len(name)
-			dentry.fname = name.encode('ascii')
+			dentry.fname = name
 			dentry.flen = size
 			
@@ -97,5 +97,5 @@
 			dentry.kind = TMPFS_DIRECTORY
 			dentry.fname_len = len(name)
-			dentry.fname = name.encode('ascii')
+			dentry.fname = name
 			
 			outf.write(dentry.pack())
@@ -122,5 +122,5 @@
 	
 	header = xstruct.create(HEADER)
-	header.tag = b"TMPFS"
+	header.tag = "TMPFS"
 	
 	outf.write(header.pack())
